---
name: Bug report
title: 'Bug title for [appname]'
about: Report a bug encountered while using websoft9's product
labels: bug
---

**Describe the bug**

A clear and concise description of what the bug is.

## Deployment method

- [ ] subscription image from MarketPlace of Cloud
- [ ] All-in-one Installer
- [ ] ansible-playbook cli
- [ ] mcloud
- [ ] create instance from private image

## Bug source

- [ ] Bugs from installation 
- [ ] Bugs from first use
- [ ] Other (You should describe it)   

## System Environment

**Application Version**

e.g v4.5

**OS**

- [ ] Ubuntu18.x
- [ ] Ubuntu20.x
- [ ] Ubuntu22.x
- [ ] CentOS7.x
- [ ] CentOS8.x
- [ ] AmazonLinux2
- [ ] OracleLinux7.8
- [ ] OracleLinux8.2
- [ ] Other (You should describe it) 

**Cloud PlatForm**

- [ ] Azure
- [ ] Aws
- [ ] 阿里云
- [ ] 腾讯云
- [ ] 华为云
- [ ] AlibabaCloud
- [ ] HUWEICloud
- [ ] Other (You should describe it) 


## Bug reproduce

Steps to reproduce the behavior:

1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

## Bug reports

### Bug Context

Bug context includes bug error, error logs and service status, it is very important for resolving issue

```
# bug error
(paste here) 

# service status 
(paste here) 

# error logs
(paste here) 
```

### Bug Screenshot

paste screenshot here

## Your suggestion

**The reason of Bug**

You can describe the reason if you have found it

**Your solution for Bug**

You can describe your solution here

**Additional context**

You can add any other context about the problem here.
